
function [Rate_common_1,Rate_common_2,Rate_private_1,Rate_private_2,SumRate_]= SUNOMA_scheme(P_tot_dB, alpha_CSIT,noise_3_dB, N_real,Rate_user_zero_tdma, exp_pow_pri_)

M=2; %Tx antennas 

noise_12=1;

noise_3=10^(noise_3_dB/10);

step_f=0.0005;

% 
L=length(0:step_f:1);

%L=1;

Rate_common_1=zeros(1,P_tot_dB+1);

Rate_common_2=zeros(1,P_tot_dB+1);

Rate_private_1=zeros(1,P_tot_dB+1);

Rate_private_2=zeros(1,P_tot_dB+1);

Rate_common_1_=zeros(P_tot_dB+1,L);

Rate_common_2_=zeros(P_tot_dB+1,L);

Rate_private_1_=zeros(P_tot_dB+1,L);

Rate_private_2_=zeros(P_tot_dB+1,L);

Rate_user_zero=zeros(1,P_tot_dB+1);

%N_real=500;

H_err_rea=zeros(M,M);

H_est=zeros(M,M);

W_3=transpose([1 zeros(1,M-1)]);


for n=1:N_real
   
        %H_zeros(:,1)=H_alpha(:,1);
        
         H_est_rea=(1/sqrt(2)*randn(M,M)+1j*1/sqrt(2)*randn(M,M));
       
         H_err_rea=(1/sqrt(2)*randn(M,M)+1j*1/sqrt(2)*randn(M,M));
         
         H_zeros(:,1)=1/sqrt(2)*randn(M,1)+1j*1/sqrt(2)*randn(M,1);
         
         W_real=inv(H_est_rea');
         
         [U,~,~]=svd(H_est);
         
          W_comm=U(:,1); %to see this one common symbol user 1 and 2;
         
        
         for P_dB=0:P_tot_dB
             
             P=10^(P_dB/10);
         
             error=0.95*P^(-alpha_CSIT);
             
             H_err=H_err_rea*sqrt(error);
                        
             H_est=H_est_rea*sqrt(1-error);
     
             H_alpha=H_est+H_err;
        
             W=W_real/(1-error^2); % BF matrix to check
        
                    for k=1:M
           
                          W(:,k)=W(:,k)/norm(W(:,k)); %Normalization
           
                    end
                    

         
        % 2 users with alpha
        
             G_alpha=H_alpha'*W;
        
             G_alpha_comm_12=H_alpha'*W_comm;
             
             G_alpha_3=H_alpha'*W_3;
             
             G_zero_alpha=H_zeros'*W;
             
             G_zero_comm_12=H_zeros'*W_comm;
             
             G_zero_3=H_zeros'*W_3;
             
             % We want to analyze the rates of users 1 and 2, while
             % mantaining the rate of user 3
             [Rate_common_1_rea, Rate_common_2_rea ,Rate_private_1_rea, Rate_private_2_rea] = SUNOMA_opt(exp_pow_pri_,G_alpha,G_alpha_comm_12, G_alpha_3, G_zero_alpha, G_zero_comm_12,  G_zero_3 ,P,noise_12,noise_3,step_f);
             
             Rate_common_1_(P_dB+1,:)=Rate_common_1_(P_dB+1,:)+Rate_common_1_rea;
             
             Rate_common_2_(P_dB+1,:)=Rate_common_2_(P_dB+1,:)+Rate_common_2_rea;
             
             Rate_private_1_(P_dB+1,:)=Rate_private_1_(P_dB+1,:)+Rate_private_1_rea;
             
             Rate_private_2_(P_dB+1,:)=Rate_private_2_(P_dB+1,:)+Rate_private_2_rea;
             
 
                             
         end
          
end

Rate_private_1_=Rate_private_1_/N_real;

Rate_private_2_=Rate_private_2_/N_real;

Rate_common_1_=Rate_common_1_/N_real;

Rate_common_2_=Rate_common_2_/N_real;


  %This function searches for the combination (f_1,f_2,f_3) such that Rate
  %user 3 is as in case of Time Partitioning, but you maximize the rate of
  %user 1 and 2. 
 index=opt_rate(Rate_common_1_,Rate_private_1_+Rate_private_2_+Rate_common_1_+Rate_common_2_,Rate_user_zero_tdma);


 for  P_dB=0:P_tot_dB
             
         
    Rate_private_1(P_dB+1)=Rate_private_1_(P_dB+1,index(P_dB+1));
         
    Rate_private_2(P_dB+1)=Rate_private_2_(P_dB+1,index(P_dB+1));
         
    Rate_common_1(P_dB+1)=Rate_common_1_(P_dB+1,index(P_dB+1));
    
    Rate_common_2(P_dB+1)=Rate_common_2_(P_dB+1,index(P_dB+1));
 end

SumRate_=Rate_common_1 + Rate_common_2 +Rate_private_1+Rate_private_2+Rate_user_zero;


return