

function [SumRate_two_alpha_, SumRate_ , Rate_user_zero ] =  TDMA_RS_scheme(P_tot_dB, alpha_CSIT,t,noise_3_dB, N_real)


M=2; %Tx antennas 

noise_12=1;

noise_3=10^(noise_3_dB/10);

Rate_common=zeros(1,P_tot_dB+1);

Rate_private_1=zeros(1,P_tot_dB+1);

Rate_private_2=zeros(1,P_tot_dB+1);

Rate_common_=zeros(1,P_tot_dB+1);

Rate_private_1_=zeros(1,P_tot_dB+1);

Rate_private_2_=zeros(1, P_tot_dB+1);

Rate_user_zero_=zeros(1, P_tot_dB+1);

Rate_user_zero=zeros(1,P_tot_dB+1);

%N_real=500;

H_err_rea=zeros(M,M);

H_est=zeros(M,M);

W_3=transpose([1 zeros(1,M-1)]); % Precoder user 3


for n=1:N_real
   
        %H_zeros(:,1)=H_alpha(:,1);
        
         H_est_rea=(1/sqrt(2)*randn(M,M)+1j*1/sqrt(2)*randn(M,M)); %generation of the channel estimate for users 1 and 2 - known at the BS
       
         H_err_rea=(1/sqrt(2)*randn(M,M)+1j*1/sqrt(2)*randn(M,M)); %generation of the CSIT error for users 1 and 2
         
         H_zeros(:,1)=1/sqrt(2)*randn(M,1)+1j*1/sqrt(2)*randn(M,1); %generation of the channel for user 3 - not known at the BS
         
         W_real=inv(H_est_rea'); %you get here the precoders of the private symbols  - you have to conjugate the channel
         
         [U,~,~]=svd(H_est); %precoder of the common symbol of RS
         
         W_comm=U(:,1); %to see this one common symbol user 1 and 2;
         
        
         for P_dB=0:P_tot_dB
             
             P=10^(P_dB/10); %power of the signal
         
             error=0.95*P^(-alpha_CSIT); %you generate the magnitude of the error
             
             H_err=H_err_rea*sqrt(error); %you generate the CSIT error for user 1 and 2
                        
             H_est=H_est_rea*sqrt(1-error); %this is the estimation of the channel at the BS - known at the BS
     
             H_alpha=H_est+H_err; %this is the real channel - unknow at the BS
        
             W=W_real/(1-error^2); % BF matrix - useless line 
        
                    for k=1:M
           
                          W(:,k)=W(:,k)/norm(W(:,k)); %Normalization - each columns become unitary 
           
                    end
                    

         %   W_comm=transpose([1 zeros(1,M-1)]); 
         
        % 2 users with alpha
        
             G_alpha=H_alpha'*W; %G_{\alpha} is the received signal for the private symbols 
         
             G_alpha_comm=H_alpha'*W_comm; %received signal for the common symbol 
             
             G=H_zeros'*W_3; %received signal for user 3 (the one without CSIT)
             
             %the outputs of the function below are the rates of the
             %private symbols, the common symbol and the symbol for user 3
             
             [Rate_common_rea, Rate_private_1_rea, Rate_private_2_rea, Rate_user_zero_rea] = RS_opt_TDMA (alpha_CSIT, G_alpha_comm,G_alpha,G,P,noise_12,noise_3);
             
             Rate_common_(P_dB+1)=Rate_common_(P_dB+1)+Rate_common_rea;
             
             Rate_private_1_(P_dB+1)=Rate_private_1_(P_dB+1)+Rate_private_1_rea;
             
             Rate_private_2_(P_dB+1)=Rate_private_2_(P_dB+1)+Rate_private_2_rea;
             
             Rate_user_zero_(P_dB+1)=Rate_user_zero_(P_dB+1)+Rate_user_zero_rea;
               
         end
         
       
end

Rate_private_1_=Rate_private_1_/N_real;

Rate_private_2_=Rate_private_2_/N_real;

Rate_common_=Rate_common_/N_real;

Rate_user_zero_=Rate_user_zero_/N_real;
 

Rate_common=t*Rate_common_;

Rate_private_1=t*Rate_private_1_;

Rate_private_2=t*Rate_private_2_;

Rate_user_zero=(1-t)*Rate_user_zero_;

SumRate_two_alpha_=Rate_private_1+Rate_private_2+Rate_common;

SumRate_=Rate_common+Rate_private_1+Rate_private_2+Rate_user_zero;


return 